using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

namespace Caa
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter
                = "ͼƬ|*.jpg;*.jpeg;*.bmp;*.png;*.tiff|ļ|*.*";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                pictureBox1.Load(ofd.FileName);
                textBox1.Text = Path.GetFileName(ofd.FileName);
                button2.Enabled = true;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string art
                = AsciiArtGenerator.Generate(
                (Bitmap)pictureBox1.Image,
                (int)numericUpDown1.Value,
                (int)numericUpDown2.Value
                );
            string path = Path.Combine(
                          Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory),
                          "caa_"
                          + Path.GetFileNameWithoutExtension(
                          Path.GetRandomFileName())
                          + ".html");
            using (StreamWriter sw
                = new StreamWriter(path))
            {
                sw.WriteLine("<HTML>");
                sw.WriteLine("<HEAD>");
                sw.WriteLine("<TITLE>");
                sw.WriteLine(textBox1.Text);
                sw.WriteLine("</TITLE>");
                sw.WriteLine("</HEAD>");
                sw.WriteLine("<BODY STYLE=\"font-family:Courier New;\">");
                sw.WriteLine("<H1>Conmajia's ASCII Art</H1>");
                sw.WriteLine("<strong>File</strong>: " + textBox1.Text + "<br/>");
                sw.WriteLine(
                    "<strong>Created on</strong>: "
                    + DateTime.Now.ToString()
                    + "<br/>"
                    );
                sw.WriteLine("<HR SIZE=\"1\" NOSHADOW />");
                sw.WriteLine("<PRE>");
                sw.Write(
                    art.Replace(Environment.NewLine, "<br/>")
                    );
                sw.WriteLine("</PRE>");
                sw.WriteLine();
                sw.WriteLine("</BODY>");
                sw.WriteLine("</HTML>");
            }
            Process.Start("file://" + path);
        }
    }
}